searchNodes=[{"ref":"ExInsights.html","title":"ExInsights","type":"module","doc":"Exposes methods for POST events &amp; metrics to Azure Application Insights. For more information on initialization and usage consult the README.md"},{"ref":"ExInsights.html#read_instrumentation_key/1","title":"ExInsights.read_instrumentation_key/1","type":"function","doc":""},{"ref":"ExInsights.html#track_dependency/8","title":"ExInsights.track_dependency/8","type":"function","doc":"Log a dependency, for example requests to an external service or SQL calls. Parameters: name: String that identifies the dependency. command_name: String of the name of the command made against the dependency (eg. full URL with querystring or SQL command text). elapsed_time_ms: Number for elapsed time in milliseconds of the command made against the dependency. success: Boolean which indicates success. dependency_type_name: String which denotes dependency type. Defaults to nil. target: String of the target host of the dependency. properties (optional): map[string, string] - additional data used to filter events and metrics in the portal. Defaults to empty. instrumentation_key (optional): Azure application insights API key. If not set it will be read from the configuration (see README.md)"},{"ref":"ExInsights.html#track_event/4","title":"ExInsights.track_event/4","type":"function","doc":"Log a user action or other occurrence. Parameters: name: name of the event (string) properties (optional): a map of [string -&gt; string] pairs for adding extra properties to this event measurements (optional): a map of [string -&gt; number] values associated with this event that can be aggregated/sumed/etc. on the UI instrumentation_key (optional): Azure application insights API key. If not set it will be read from the configuration (see README.md)"},{"ref":"ExInsights.html#track_exception/6","title":"ExInsights.track_exception/6","type":"function","doc":"Log an exception you have caught. Parameters: exception: An Error from a catch clause, or the string error message. stack_trace: An erlang stacktrace. properties: map[string, string] - additional data used to filter events and metrics in the portal. Defaults to empty. measurements: map[string, number] - metrics associated with this event, displayed in Metrics Explorer on the portal. Defaults to empty. instrumentation_key (optional): Azure application insights API key. If not set it will be read from the configuration (see README.md)"},{"ref":"ExInsights.html#track_metric/4","title":"ExInsights.track_metric/4","type":"function","doc":"Log a numeric value that is not associated with a specific event. Typically used to send regular reports of performance indicators. Parameters: name: name of the metric value: the value of the metric (number) properties (optional): a map of [string -&gt; string] pairs for adding extra properties to this event instrumentation_key (optional): Azure application insights API key. If not set it will be read from the configuration (see README.md)"},{"ref":"ExInsights.html#track_request/9","title":"ExInsights.track_request/9","type":"function","doc":"Log a request, for example incoming HTTP requests Parameters: name: String that identifies the request url: Request URL source: Request Source. Encapsulates info about the component that initiated the request (can be nil) elapsed_time_ms: Number for elapsed time in milliseconds result_code: Result code reported by the application success: whether the request was successfull properties (optional): map[string, string] - additional data used to filter events and metrics in the portal. Defaults to empty. measurements (optional): a map of [string -&gt; number] values associated with this event that can be aggregated/sumed/etc. on the UI instrumentation_key (optional): Azure application insights API key. If not set it will be read from the configuration (see README.md)"},{"ref":"ExInsights.html#track_trace/4","title":"ExInsights.track_trace/4","type":"function","doc":"Log a trace message. Parameters: message: A string to identify this event in the portal. severity_level: The level of severity for the event. properties: map[string, string] - additional data used to filter events and metrics in the portal. Defaults to empty. instrumentation_key (optional): Azure application insights API key. If not set it will be read from the configuration (see README.md)"},{"ref":"ExInsights.html#t:instrumentation_key/0","title":"ExInsights.instrumentation_key/0","type":"type","doc":""},{"ref":"ExInsights.html#t:measurements/0","title":"ExInsights.measurements/0","type":"type","doc":"A map of [name -&gt; number] to add measurement data to a tracking request"},{"ref":"ExInsights.html#t:name/0","title":"ExInsights.name/0","type":"type","doc":"Measurement name. Will be used extensively in the app insights UI"},{"ref":"ExInsights.html#t:properties/0","title":"ExInsights.properties/0","type":"type","doc":"A map of [name -&gt; string] to add metadata to a tracking request"},{"ref":"ExInsights.html#t:severity_level/0","title":"ExInsights.severity_level/0","type":"type","doc":"Defines the level of severity for the event."},{"ref":"ExInsights.html#t:stack_trace/0","title":"ExInsights.stack_trace/0","type":"type","doc":"Represents the exception&#39;s stack trace."},{"ref":"ExInsights.html#t:stack_trace_entry/0","title":"ExInsights.stack_trace_entry/0","type":"type","doc":""},{"ref":"ExInsights.Aggregation.Worker.html","title":"ExInsights.Aggregation.Worker","type":"module","doc":"A named genserver responsible for batching telemetry requests. Fires up a separate process every 30secs (configurable) to upload the data to azure"},{"ref":"ExInsights.Aggregation.Worker.html#child_spec/1","title":"ExInsights.Aggregation.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExInsights.Aggregation.Worker.html#flush/0","title":"ExInsights.Aggregation.Worker.flush/0","type":"function","doc":"Sends any pending messages to azure. Required for Elixir.Logger hookup"},{"ref":"ExInsights.Aggregation.Worker.html#init/1","title":"ExInsights.Aggregation.Worker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"ExInsights.Client.ClientBehaviour.html","title":"ExInsights.Client.ClientBehaviour","type":"behaviour","doc":"Defines mathods to be implemented by app insights clients. Used as a common interface for actual and test clients"},{"ref":"ExInsights.Client.ClientBehaviour.html#c:track/1","title":"ExInsights.Client.ClientBehaviour.track/1","type":"callback","doc":"Invoked to send telemetry data to azure"},{"ref":"ExInsights.Client.HttpClient.html","title":"ExInsights.Client.HttpClient","type":"module","doc":"Responsible for actually sending track requests (HTTP POSTs) to azure app insights. Intended for internal use only."},{"ref":"ExInsights.Client.HttpClient.html#track/1","title":"ExInsights.Client.HttpClient.track/1","type":"function","doc":"POSTs track requests to azure app insights. Internal use only."},{"ref":"ExInsights.Client.TestClient.html","title":"ExInsights.Client.TestClient","type":"module","doc":"Test client module that implements the ExInsights.Client.ClientBehaviour Implemented as a GenServer to add reporting for test purposes"},{"ref":"ExInsights.Client.TestClient.html#child_spec/1","title":"ExInsights.Client.TestClient.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExInsights.Client.TestClient.html#clear_listeners/0","title":"ExInsights.Client.TestClient.clear_listeners/0","type":"function","doc":""},{"ref":"ExInsights.Client.TestClient.html#start/0","title":"ExInsights.Client.TestClient.start/0","type":"function","doc":""},{"ref":"ExInsights.Client.TestClient.html#subscribe/0","title":"ExInsights.Client.TestClient.subscribe/0","type":"function","doc":""},{"ref":"ExInsights.Configuration.html","title":"ExInsights.Configuration","type":"module","doc":"Internal module for reading configuration values"},{"ref":"ExInsights.Configuration.html#get_value/2","title":"ExInsights.Configuration.get_value/2","type":"function","doc":"Reads configuration related to the ex_insights app. Provides support for {:system, &quot;VAR_NAME&quot;} configuration. Intended for internal use."},{"ref":"ExInsights.Data.Envelope.html","title":"ExInsights.Data.Envelope","type":"module","doc":"Track request envelope Envelope data looks like this { &quot;time&quot;: &quot;2017-08-24T08:55:56.968Z&quot;, &quot;iKey&quot;: &quot;some-guid-value-key&quot;, &quot;name&quot;: &quot;Microsoft.ApplicationInsights.someguidvaluekey.Event&quot;, &quot;tags&quot;: { &quot;ai.session.id&quot;: &quot;SLzGH&quot;, &quot;ai.device.id&quot;: &quot;browser&quot;, &quot;ai.device.type&quot;: &quot;Browser&quot;, &quot;ai.internal.sdkVersion&quot;: &quot;javascript:1.0.11&quot;, &quot;ai.user.id&quot;: &quot;V2Yph&quot;, &quot;ai.operation.id&quot;: &quot;VKgP+&quot;, &quot;ai.operation.name&quot;: &quot;/&quot; }, &quot;data&quot;: { &quot;baseType&quot;: &quot;EventData&quot;, &quot;baseData&quot;: { &quot;ver&quot;: 2, &quot;name&quot;: &quot;button clicked&quot;, &quot;properties&quot;: { &quot;click type&quot;: &quot;double click&quot; }, &quot;measurements&quot;: { &quot;clicks&quot;: 2 } } } }"},{"ref":"ExInsights.Data.Envelope.html#create/4","title":"ExInsights.Data.Envelope.create/4","type":"function","doc":"Creates a new envelope for sending a single tracked item to app insights. Intended for internal use only."},{"ref":"ExInsights.Data.Envelope.html#ensure_instrumentation_key_present/1","title":"ExInsights.Data.Envelope.ensure_instrumentation_key_present/1","type":"function","doc":""},{"ref":"ExInsights.Data.Envelope.html#get_tags/0","title":"ExInsights.Data.Envelope.get_tags/0","type":"function","doc":"Provides common tags for all track requests. Intended for internal use only."},{"ref":"ExInsights.Data.Envelope.html#set_instrumentation_key/2","title":"ExInsights.Data.Envelope.set_instrumentation_key/2","type":"function","doc":""},{"ref":"ExInsights.Data.Envelope.html#t:t/0","title":"ExInsights.Data.Envelope.t/0","type":"type","doc":""},{"ref":"ExInsights.Data.Payload.html","title":"ExInsights.Data.Payload","type":"module","doc":"Central point for creating data objects. Intended for internal use."},{"ref":"ExInsights.Data.Payload.html#create_dependency_payload/7","title":"ExInsights.Data.Payload.create_dependency_payload/7","type":"function","doc":"Create custom dependency payload."},{"ref":"ExInsights.Data.Payload.html#create_event_payload/3","title":"ExInsights.Data.Payload.create_event_payload/3","type":"function","doc":"Create custom event payload."},{"ref":"ExInsights.Data.Payload.html#create_exception_payload/5","title":"ExInsights.Data.Payload.create_exception_payload/5","type":"function","doc":"Create custom exception payload."},{"ref":"ExInsights.Data.Payload.html#create_metric_payload/3","title":"ExInsights.Data.Payload.create_metric_payload/3","type":"function","doc":"Create custom metric payload."},{"ref":"ExInsights.Data.Payload.html#create_request_payload/8","title":"ExInsights.Data.Payload.create_request_payload/8","type":"function","doc":"Create request payload"},{"ref":"ExInsights.Data.Payload.html#create_trace_payload/3","title":"ExInsights.Data.Payload.create_trace_payload/3","type":"function","doc":"Create custom trace payload."},{"ref":"ExInsights.Decoration.Attributes.html","title":"ExInsights.Decoration.Attributes","type":"module","doc":"Injects decorator functions into parent module to streamline telemetry logging in aspect-oriented style"},{"ref":"ExInsights.Decoration.Attributes.html#do_track_dependency/7","title":"ExInsights.Decoration.Attributes.do_track_dependency/7","type":"function","doc":""},{"ref":"ExInsights.Decoration.Attributes.html#success?/1","title":"ExInsights.Decoration.Attributes.success?/1","type":"function","doc":""},{"ref":"ExInsights.Decoration.Attributes.html#track_dependency/1","title":"ExInsights.Decoration.Attributes.track_dependency/1","type":"macro","doc":""},{"ref":"ExInsights.Decoration.Attributes.html#track_dependency/3","title":"ExInsights.Decoration.Attributes.track_dependency/3","type":"function","doc":""},{"ref":"ExInsights.Decoration.Attributes.html#track_event/0","title":"ExInsights.Decoration.Attributes.track_event/0","type":"macro","doc":""},{"ref":"ExInsights.Decoration.Attributes.html#track_event/2","title":"ExInsights.Decoration.Attributes.track_event/2","type":"function","doc":""},{"ref":"ExInsights.Decoration.Attributes.html#track_exception/0","title":"ExInsights.Decoration.Attributes.track_exception/0","type":"macro","doc":""},{"ref":"ExInsights.Decoration.Attributes.html#track_exception/2","title":"ExInsights.Decoration.Attributes.track_exception/2","type":"function","doc":""},{"ref":"readme.html","title":"ExInsights","type":"extras","doc":"ExInsights Elixir client library to log telemetry data on Azure Application Insights."},{"ref":"readme.html#installation","title":"ExInsights - Installation","type":"extras","doc":"Install from hex by adding ex_insights to your list of dependencies in mix.exs: def deps do [ {:ex_insights, &quot;~&gt; 0.5&quot;} ] end Note: The library is packaged as an application. In elixir &lt;= 1.3.x you will need to add it explicitly to the list of applications started before your own inside mix.exs like this: # This step is only required for older elixir installations def application do [ applications: [:ex_insights] ] end"},{"ref":"readme.html#configuration","title":"ExInsights - Configuration","type":"extras","doc":"Instrumentation key You need at the very least to set your instrumentation key in order to start accepting telemetry requests on azure. You can do this by setting the instrumentation_key property like this: config :ex_insights, instrumentation_key: &quot;0000-1111-2222-3333&quot; You can also use an environment variable instead if that&#39;s your preference config :ex_insights, instrumentation_key: {:system, &quot;INSTRUMENTATION_KEY&quot;} # at runtime the application will look for the INSTRUMENTATION_KEY environment variable If you forget to set the key the application will raise with an appropriate message anytime an ExInsights.track_xxx function is used. Notes As of version 0.5 you can also set the instrumentation key per request. Flush interval You can also set the flush interval in seconds (ie the interval at which data will be sent over to azure). The default is 30 seconds. config :ex_insights, flush_interval_secs: 30"},{"ref":"readme.html#usage","title":"ExInsights - Usage","type":"extras","doc":"Basic Usage All public tracking methods are under the ExInsights module. Examples: # will post a click custom_event to azure ExInsights.track_event(&quot;click&quot;) # with custom defined property &quot;type&quot; and measurement &quot;count&quot; ExInsights.track_event(&quot;click&quot;, %{type: &quot;button&quot;}, %{count: 2}) # send custom metric data. Does not support aggregated data (count/stdDev, min, max) ExInsights.track_metric(&quot;bananas&quot;, 10) # log arbitrary data ExInsights.track_trace(&quot;1-2-3 boom&quot;, :warning) # log time taken for requests to external resources, eg. database or http service calls ExInsights.track_dependency(&quot;get_user_balance&quot;, &quot;http://my.api/get_balance/aviator1&quot;, 1500, true, &quot;user&quot;, &quot;my.api&quot;) # log telemetry data about the incoming request processed by the application ExInsights.track_request(&quot;homepage&quot;, &quot;http://my.site.com/&quot;, &quot;HomePageComponent&quot;, 85, 200, true) For more details and optional arguments look at the ExInsights module documentation. Alternative usage You can also decorate methods you need to track using decorators. # Make sure to add the following line before using any decorators use ExInsights.Decoration.Attributes # add the @decorate track_xxx() attribute right above each function you need to track @decorate track_event() # will log the &quot;update_user_email&quot; event in AppInsights on funtion entry def update_user_email(email, user) do # ... end @decorate track_dependency(&quot;user-actions&quot;) # put under dependency type:user-actions in AppInsights UI def login_user(user) do # ... maybe call external api here end @decorate track_exception() # will track errors and exits def dangerous_stuff do # ... do work that may fail end"},{"ref":"readme.html#inner-workings","title":"ExInsights - Inner workings","type":"extras","doc":"Calling any tracking function ExInsights.track_xxx from your code will not immediately send the data to Azure. It will instead be aggregated in memory until the flush_timer is triggered (every 30 secs, configurable) and the data will be batch sent. When the application shuts down it will attempt to flush any remaining data. If you are behind a firewall (usually happens in production deployments) make sure your network rules allow HTTP POSTs to https://dc.services.visualstudio.com If requests to azure tracking services fail (network or server errors or bad requests) you will not be alerted. track_dependency and track_exception decorators will try to rescue/catch any errors (and log those) and then re-raise the error / exit as appropriate. This is a different (but hopefully working) approach than what the AppSignal guys do (a separate process monitoring crashes)"}]